"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sub = exports.flatten = exports.chainFirst = exports.apSecond = exports.apFirst = exports.Profunctor = exports.promap = exports.Monad = exports.Chain = exports.chain = exports.Applicative = exports.Apply = exports.ap = exports.Pointed = exports.of = exports.Functor = exports.map = exports.getMonoid = exports.none = exports.fromCmd = exports.fromObservable = exports.URI = void 0;
const R = __importStar(require("fp-ts-rxjs/lib/Observable"));
const RO = __importStar(require("fp-ts-rxjs/lib/ReaderObservable"));
const Apply_1 = require("fp-ts/lib/Apply");
const Chain_1 = require("fp-ts/lib/Chain");
const function_1 = require("fp-ts/lib/function");
const Rr = __importStar(require("fp-ts/lib/Reader"));
exports.URI = 'effe-ts/Sub';
function fromObservable(actions$) {
    return Rr.of(Rr.of(actions$));
}
exports.fromObservable = fromObservable;
function fromCmd(cmd) {
    return Rr.of(cmd);
}
exports.fromCmd = fromCmd;
const monoidObservable = RO.getMonoid();
exports.none = fromCmd(monoidObservable.empty);
function getMonoid() {
    const monoidObservable = RO.getMonoid();
    return {
        concat: (x, y) => model$ => monoidObservable.concat(x(model$), y(model$)),
        empty: exports.none
    };
}
exports.getMonoid = getMonoid;
// -------------------------------------------------------------------------------------
// non-pipeables
// -------------------------------------------------------------------------------------
const _map = (fa, f) => (0, function_1.pipe)(fa, (0, exports.map)(f));
const _ap = (fab, fa) => (0, function_1.pipe)(fab, (0, exports.ap)(fa));
const _chain = (ma, f) => (0, function_1.pipe)(ma, (0, exports.chain)(f));
const _promap = (fbc, f, g) => (0, function_1.pipe)(fbc, (0, exports.promap)(f, g));
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
const map = f => ma => (0, function_1.flow)(ma, RO.map(f));
exports.map = map;
exports.Functor = {
    URI: exports.URI,
    map: _map
};
const of = a => Rr.of(RO.of(a));
exports.of = of;
exports.Pointed = {
    URI: exports.URI,
    of: exports.of
};
const ap = ma => mab => model$ => (0, function_1.pipe)((0, Apply_1.sequenceT)(RO.Applicative)(mab(model$), ma(model$)), RO.map(([f, a]) => f(a)));
exports.ap = ap;
exports.Apply = {
    URI: exports.URI,
    map: _map,
    ap: _ap
};
exports.Applicative = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    of: exports.of
};
const chain = f => ma => model$ => (0, function_1.pipe)(ma(model$), RO.chain(a => f(a)(model$)));
exports.chain = chain;
exports.Chain = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    chain: _chain
};
exports.Monad = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    chain: _chain,
    of: exports.of
};
const promap = (f, g) => fbc => model$ => (0, function_1.pipe)(model$, R.map(f), fbc, RO.map(g));
exports.promap = promap;
exports.Profunctor = {
    URI: exports.URI,
    map: _map,
    promap: _promap
};
exports.apFirst = 
/*#__PURE__*/
(0, Apply_1.apFirst)(exports.Apply);
exports.apSecond = 
/*#__PURE__*/
(0, Apply_1.apSecond)(exports.Apply);
exports.chainFirst = 
/*#__PURE__*/
(0, Chain_1.chainFirst)(exports.Chain);
exports.flatten = (0, exports.chain)(function_1.identity);
/**
 * @deprecated
 */
exports.sub = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, exports.Applicative), exports.Chain), exports.Functor), exports.Monad), exports.Pointed), exports.Profunctor);
//# sourceMappingURL=Sub.js.map